#include <cstdio>
#include "card.h"

void Punch::CardWord::print(std::ostream& os) const {
	for(int x=0; x < word_length; x++) {
		// seperate in 3 nibbles
		if(x && x%4==0) os << " ";
		os << (bits[x]?"1":"0");
	}
	os << std::endl;
}

void Punch::Card::print(std::ostream& os) const {
	os << "/   1234 5678 9012\n";
	for(int c=0; c < col_length; c++) {
		printf("|%2d ",c);
		word[c].print(os);
	}
}

void Punch::Card::write(CardFormat format, std::ostream& os) {
	/*// default meta data (more come at some date...)
	byte_t meta_data[] = { 0x80, 0x80, 0x80 };
	os.write((char*)meta_data, 3);

	for(int pos=0; pos < Punch::CardWord::word_length;) {
		byte_t out[3];
		
		out[0]
	}*/
}

int main(int argc, char** argv) {
	// Teste:
	Punch::CardWord a,b,c;

	//    1 2 3 4 5 6 7 8 9 0 11 12
	a.set(1,0,1,1,1,0,1,1,0,1,1,1);
	b.set(0,1,1,1,1,1,1,0,0,0,1,0);
	c = a & b;
	std::cout << "A: ";
	a.print(std::cout);
	std::cout << "B: ";
	b.print(std::cout);
	std::cout << "C: ";
	c.print(std::cout);
	std::cout << std::endl;

	int x = 2;
	int y = 1;
	std::cout << "A was : ";
	a.print(std::cout);
	std::cout << "A << "<<x<<": ";
	(a << x).print(std::cout);
	std::cout << "B was : ";
	b.print(std::cout);
	std::cout << "B >> "<<y<<": ";
	(b >> y).print(std::cout);

	Punch::Card card;
	card.set(4, a);
	card.set(9, b);
	card.print(std::cout);
}
